/*****************************************************************************
 *  @file expression/expr_variable.h
 *  Functions for processing variable expressions.
 *
 *  Copyright (c) 2012 The fli4l team
 *
 *  This file is part of fli4l.
 *
 *  fli4l is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  fli4l is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with fli4l.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Last Update: $Id: expr_variable.h 23396 2012-08-14 14:48:43Z kristov $
 *****************************************************************************
 */

#ifndef MKFLI4L_EXPRESSION_EXPR_VARIABLE_H_
#define MKFLI4L_EXPRESSION_EXPR_VARIABLE_H_

#include <libmkfli4l/defs.h>
#include <expression/expr.h>
#include <var.h>

/**
 * Creates a variable expression. A variable expression is an expression that
 * references the value of a variable.
 *
 * @param scope
 *  The scope this expression lives in.
 * @param instance
 *  The variable instance associated with the expression.
 * @return
 *  A pointer to a dynamically allocated expression. Use expr_free() to destroy
 *  it.
 */
struct expr_t *
expr_variable_create(
    struct var_scope_t *scope,
    struct var_instance_t *instance
);

#endif
