#!/bin/sh

OUTPUT=$1
shift
ENTRIES=/tmp/nic-entries.$$
DRV=/tmp/nic-drv.$$

cat "$@" > ${ENTRIES}

kernels=$(cut -d# -f1 < ${ENTRIES} | uniq | sort -t. -k2,2 -n)
echo $kernels > ${OUTPUT}
for drv in $(cut -d# -f4 < ${ENTRIES} | sort -u)
do
  grep "^\([^#]\+#\)\{3\}$drv#" ${ENTRIES} > ${DRV}
  unset zeile
  for kernel in $kernels
  do
    grep -q "^$kernel#" ${DRV} && zeile="${zeile}x#" || zeile="${zeile}#"
  done
  rest=$(head -n1 < ${DRV})
  rest=${rest#*#*#}
  echo "$zeile${rest%#}"
done >> ${OUTPUT}

rm ${ENTRIES} ${DRV}
