#!/bin/sh
#--------------------------------------------------------------------
# /usr/local/bin/service-restart.sh - Run service in a loop
#
# Creation:    08.02.2003 tobig
# Last Update: $Id: service-restart.sh 18462 2010-06-03 19:58:02Z jw5 $
#--------------------------------------------------------------------

SEM=/var/run/service-restart.exit

case $1 in
    start) rm -f $SEM ; exit ;;
    stop)  > $SEM ; exit ;;
esac

if [ "$#" -lt 2 ]
then
  echo "Syntax: $0 <sleeptime> <programm> [arg1] ..."
  exit 1
fi

sleeptime="$1"
shift

if echo "$sleeptime" | grep -v "^[0-9]\+$" > /dev/null
then
  echo "Error: Sleep time is not a number!"
  exit 1
fi

if [ ! -x "$1" ]
then
  echo "Error: service not found or not executable!"
  exit 1
fi

trap "" 1

while true
do
  "$@"
  if [ -f $SEM ]; then
      logger -t "$0[$$]" "$1 terminated with $?, not restarting due to system shutdown ..."
      exit
  fi
  # logger -t "$0[$$]" "$1 terminated with $?, restarting in $sleeptime seconds"
  sleep "$sleeptime"
done
