#! /bin/sh
#------------------------------------------------------------------------------
# syslogd_rotate.sh - rotates syslog-files
# Creation:    LanSpezi 2009-02-16
# Last Update: $Id: syslogd_rotate.sh 28957 2013-12-15 21:29:42Z lanspezi $
#------------------------------------------------------------------------------

if [ -f /etc/syslog.conf -a -f /var/run/syslogd.pid -o "x$1" = "x--shutdown" ]
then

    #get syslogd-rotate configuration
    . /var/run/syslogd_rotate.conf

    dir_archiv=$SYSLOGD_ROTATE_DIR
    max=$SYSLOGD_ROTATE_MAX
    
    if [ "x$max" = "x" ]
    then
       max=1
    fi

    while read foo syslog_dest
    do
        if [ -f $syslog_dest ]
        then
            eval syslog_file=`basename $syslog_dest`
            eval dir_source=`dirname $syslog_dest`

            if [ "x$dir_archiv" = "x" ]
            then
                dir_archiv=$dir_source
            fi
            mkdir -p $dir_archiv

            if [ $max -gt 1 ] 
            then
                for n in `seq $max -1 2`
                do
                    n1=`expr $n - 1`
                    if [ -f $dir_archiv/$syslog_file.$n1 ]
                    then 
                        mv $dir_archiv/$syslog_file.$n1 $dir_archiv/$syslog_file.$n
                    fi
                done
            fi
            mv $dir_source/$syslog_file $dir_archiv/$syslog_file.1
        fi
    done < /etc/syslog.conf

    logger -t "syslogd rotate" "syslogfiles are rotated"

fi
