/*----------------------------------------------------------------------------
 *  check.h - functions for checking variables
 *
 *  Copyright (c) 2001 - Frank Meyer
 *  Copyright (c) 2001-2014 - fli4l-Team <team@fli4l.de>
 *
 *  This file is part of fli4l.
 *
 *  fli4l is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  fli4l is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with fli4l.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Creation:    2001-08-12  fm
 *  Last Update: $Id: check.h 34688 2014-11-07 12:56:15Z florian $
 *----------------------------------------------------------------------------
 */

#ifndef LIBMKFLI4L_CHECK_H_
#define LIBMKFLI4L_CHECK_H_

#include "defs.h"

#define CHECK_USER_RE           -1       /* user supplied regular expression */

#define CHECK_NON_OPTIONAL      0
#define CHECK_OPTIONAL          1
#define CHECK_REALLY_OPTIONAL   2

extern void check_init(void);
extern int read_check_file(char const *, char const *);
extern char *get_set_var_n(char const *);
extern char *check_get_var_n(char const *var);
extern char *check_get_opt_var(char const *var);
extern BOOL check_var_defined(char const *var);
extern BOOL check_var_numeric(char const *var);
extern BOOL check_var_optional(char const *var);
extern BOOL check_var_really_optional(char const *var);
extern int check_var_optional_state(char const *var);
extern BOOL check_var_weak(char const *var);
extern int check_all_variables(void);
void free_check_variables(void);
void check_add_weak_declaration(char const *package, char const *name,
                                char const *value, char ** var_n,
                                char const *file, int line,
                                int log_level);

#endif
