/*----------------------------------------------------------------------------
 *  regex.h - functions for processing regular expressions
 *
 *  Copyright (c) 2002-2005 - Jean Wolter
 *  Copyright (c) 2005-2014 - fli4l-Team <team@fli4l.de>
 *
 *  This file is part of fli4l.
 *
 *  fli4l is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  fli4l is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with fli4l.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Creation:    2002-03-01  jw5
 *  Last Update: $Id: regex.h 34688 2014-11-07 12:56:15Z florian $
 *----------------------------------------------------------------------------
 */

#ifndef LIBMKFLI4L_REGEX_H_
#define LIBMKFLI4L_REGEX_H_

#include <stddef.h>
#include <regex.h>
#include "defs.h"

int regexp_chkvar(char const *name, char const *value,
                  char const *regexp_name, char const *user_regexp);
int regexp_user(char const *value, char const *expr, size_t nmatch, regmatch_t * pmatch,
                BOOL modify_expr, char const *file, int line);
int regexp_exists(char const *name);
int regexp_find_type(char const *regexp_name);
void regexp_init(void);
int regexp_read_file(char const *expr_file);
BOOL regexp_get_expr(char const *name, regex_t **preg, char **err_msg);
int check_for_dangling_extensions(void);

int add_expression(char const *name, char const *expr, char const *error_msg,
                    BOOL extend_expr, char const *expr_file, int line);
int extend_expression(char const *name, char const *expr, char const *error_msg,
                      char const *expr_file, int line);
void compile_all_expressions(void);

#endif
